#! /usr/bin/perl -w
use strict;
use DBI;
use vars qw($mysql_user $mysql_passwd $mysql_host $mysql_database_oreon);
use vars qw($con);

my $NAME = "fan-upgradedb-centreon.pl";
my $LOG = "/var/log/centreon/fan-upgradedb-centreon.log";
my $CONF ="/etc/centreon/conf.pm";

# Include Configuration Data
require "$CONF";

sub writeLogFile($){
        open (LOG, ">> ".$LOG) || print "can't write $LOG: $!";
        print STDERR $_[0]."\n";
        print LOG localtime()." - ".$_[0]."\n";
        close LOG or warn $!;
}

sub CheckMySQLConnexion(){
   $con = DBI->connect("DBI:mysql:database=".$mysql_database_oreon.";host=".$mysql_host, $mysql_user, $mysql_passwd, {'RaiseError' => 0, 'PrintError' => 0, 'AutoCommit' => 1});
   if (!defined($con)) {
       writeLogFile("Warning when connecting to database : " . $DBI::errstr . "\n");
       return 0;
   } else{
       return 1;
   }
}

sub getCentreonVersion($){
    if (CheckMySQLConnexion()) {
        my $sth = $con->prepare("SELECT $_[0] FROM `informations` WHERE `key` = 'version' LIMIT 1;");
        if (!$sth->execute()) {
            writeLogFile("Error when getting centreon version : ".$sth->errstr);
        }
        my $data = $sth->fetchrow_hashref();
        return $data->{$_[0]};
    }
}

### MAIN ###
my $numArgs = $#ARGV + 1;
if ($numArgs != 3) {
    print "Usage: $NAME <newversion> <installdir> <state>\n";
    print "       $NAME 2.0.2 /usr/share/centreon/www/install $1\n";
    print "\n";
    print "If <newversion> is present in centreon database then <installdir> is moved in old\n";
    print "<state> equal $1\n";
    exit 1;
}

my $new_version = $ARGV[0];
my $install_dir = $ARGV[1];
my $state = $ARGV[2];

if ($state == 1 && !CheckMySQLConnexion()) {
    # First install and can't connect to centreon database
    rename($install_dir,$install_dir.".old") || writeLogFile ("Can't rename $install_dir"); 
    exit 0;
}

my $last_version = getCentreonVersion("value");
if ($new_version eq $last_version) {
    rename($install_dir,$install_dir.".old") || writeLogFile ("Can't rename $install_dir"); 
    exit 0;
}

